#!/usr/local/bin/perl
# bootup.cgi
# Create, enable or disable usermin startup at boot time
# XXX caldera daemons file

require './usermin-lib.pl';
&foreign_require("init", "init-lib.pl");
&ReadParse();

if ($in{'boot'} == $in{'starting'}) {
	# Nothing to do!
	&redirect("");
	exit;
	}

($initrl) = &init::get_inittab_runlevel();
%iconfig = &foreign_config("init");
if ($iconfig{'daemons_dir'} &&
    &read_env_file("$iconfig{'daemons_dir'}/usermin", \%daemon)) {
	$daemon++;
	}
if ($in{'boot'}) {
	# Enable starting at boot
	$start_order = "9" x $iconfig{'order_digits'};
	$stop_order = "9" x $iconfig{'order_digits'};
	if ($in{'exists'} && $daemon) {
		# Just update daemons file
		$daemon{'ONBOOT'} = 'yes';
		&write_env_file("$iconfig{'daemons_dir'}/usermin", \%daemon);
		}
	elsif ($in{'exists'}) {
		# Just link up the init script
		&init::add_rl_action("usermin", $initrl, "S", $start_order);
		&init::add_rl_action("usermin", $initrl, "K", $stop_order);
		}
	else {
		# Need to create the init script
		$fn = &init::action_filename("usermin");
		open(ACTION, ">$fn");
		$desc = "Start/stop Usermin";
		print ACTION "#!/bin/sh\n";
		if ($iconfig{'chkconfig'}) {
			# Redhat-style description: and chkconfig: lines
			print ACTION "# description: $desc\n";
			print ACTION "# chkconfig: $iconfig{'chkconfig'} ",
				     "$start_order $stop_order\n";
			}
		elsif ($iconfig{'init_info'}) {
			# Suse-style init info section
			print ACTION "### BEGIN INIT INFO\n",
				     "# Provides: usermin\n",
				     "# Default-Start: $initrl\n",
				     "# Description: $desc\n",
				     "### END INIT INFO\n";
			}
		else {
			# Just description in a comment
			print ACTION "# $desc\n";
			}
		print ACTION "\n";
		print ACTION "case \"\$1\" in\n";

		print ACTION "'start')\n";
		print ACTION "\t$config{'usermin_dir'}/start\n";
		print ACTION "\tRETVAL=\$?\n";
		if ($iconfig{'subsys'}) {
			print ACTION "\tif [ \"\$RETVAL\" = \"0\" ]; then\n";
			print ACTION "\t\ttouch $iconfig{'subsys'}/usermin\n";
			print ACTION "\tfi\n";
			}
		print ACTION "\t;;\n";

		print ACTION "'stop')\n";
		print ACTION "\t$config{'usermin_dir'}/stop\n";
		print ACTION "\tRETVAL=\$?\n";
		if ($iconfig{'subsys'}) {
			print ACTION "\tif [ \"\$RETVAL\" = \"0\" ]; then\n";
			print ACTION "\t\trm -f $iconfig{'subsys'}/usermin\n";
			print ACTION "\tfi\n";
			}
		print ACTION "\t;;\n";

		print ACTION "'status')\n";
		print ACTION "\tpidfile=`grep \"^pidfile=\" $config{'usermin_dir'}/miniserv.conf | sed -e 's/pidfile=//g'`\n";
		print ACTION "\tif [ -s \$pidfile ]; then\n";
		print ACTION "\t\tpid=`cat \$pidfile`\n";
		print ACTION "\t\tkill -0 \$pid >/dev/null 2>&1\n";
		print ACTION "\t\tif [ \"\$?\" = \"0\" ]; then\n";
		print ACTION "\t\t\techo \"usermin (pid \$pid) is running\"\n";
		print ACTION "\t\t\tRETVAL=0\n";
		print ACTION "\t\telse\n";
		print ACTION "\t\t\techo \"usermin is stopped\"\n";
		print ACTION "\t\t\tRETVAL=1\n";
		print ACTION "\t\tfi\n";
		print ACTION "\telse\n";
		print ACTION "\t\techo \"usermin is stopped\"\n";
		print ACTION "\t\tRETVAL=1\n";
		print ACTION "\tfi\n";
		print ACTION "\t;;\n";

		print ACTION "'restart')\n";
		print ACTION "\t$config{'usermin_dir'}/stop && $config{'usermin_dir'}/start\n";
		print ACTION "\tRETVAL=\$?\n";
		print ACTION "\t;;\n";

		print ACTION "*)\n";
		print ACTION "\techo \"Usage: \$0 { start | stop }\"\n";
		print ACTION "\tRETVAL=1\n";
		print ACTION "\t;;\n";
		print ACTION "esac\n";
		print ACTION "exit \$RETVAL\n";
		close(ACTION);
		chmod(0755, $fn);
		&init::add_rl_action("usermin", $initrl, "S", $start_order);
		&init::add_rl_action("usermin", $initrl, "K", $stop_order);
		}
	}
else {
	# Disable starting at boot
	if ($daemon) {
		# Update daemons file
		$daemon{'ONBOOT'} = 'no';
		&write_env_file("$iconfig{'daemons_dir'}/usermin", \%daemon);
		}
	else {
		# Just unlink the init script
		foreach (&init::action_levels('S', "usermin")) {
			/^(\S+)\s+(\S+)\s+(\S+)$/;
			&init::delete_rl_action("usermin", $1, 'S');
			}
		foreach (&init::action_levels('K', "usermin")) {
			/^(\S+)\s+(\S+)\s+(\S+)$/;
			&init::delete_rl_action("usermin", $1, 'K');
			}
		}
	}
&redirect("");

