#!/usr/local/bin/perl
# index.cgi
# Display usermin configuration categories

require './usermin-lib.pl';

if (!-r "$config{'usermin_dir'}/miniserv.conf") {
	&header($text{'index_title'}, "", undef, 1, 1);
	print "<hr>\n";
	print "<p>",&text('index_econfig', "<tt>$config{'usermin_dir'}</tt>",
			  "$gconfig{'webprefix'}/config.cgi?$module_name"),"<p>\n";
	print "<hr>\n";
	&footer("/", $text{'index'});
	exit;
	}

&header($text{'index_title'}, "", undef, 1, 1, 0,
	&help_search_link("usermin", "google"), undef, undef,
	&text('index_version', &get_usermin_version()));
print "<hr>\n";

@links = ( "edit_access.cgi", "edit_bind.cgi", "edit_ui.cgi", "edit_mods.cgi",
	   "edit_os.cgi", "edit_lang.cgi", "edit_upgrade.cgi",
	   "edit_session.cgi", "edit_assignment.cgi", "edit_categories.cgi",
	   "edit_themes.cgi", "edit_ssl.cgi", "edit_configs.cgi",
	   "edit_acl.cgi", "edit_users.cgi", "edit_defacl.cgi" );
@titles = map { /_(\S+).cgi/; $text{"${1}_title"} } @links;
@icons = map { /_(\S+).cgi/; "images/$1.gif" } @links;
&icons_table(\@links, \@titles, \@icons);

print "<hr>\n";
print "<table width=100%><tr>\n";
&get_usermin_miniserv_config(\%miniserv);
if (open(PID, $miniserv{'pidfile'}) && ($pid = int(<PID>)) && kill(0, $pid)) {
	close(PID);
	print "<form action=stop.cgi>\n";
	print "<td><input type=submit value='$text{'index_stop'}'></td>\n";
	print "<td>$text{'index_stopmsg'}</td></form>\n";
	}
else {
	print "<form action=start.cgi>\n";
	print "<td><input type=submit value='$text{'index_start'}'></td>\n";
	print "<td>$text{'index_startmsg'}</td></form>\n";
	}
print "</tr></table>\n";

if (&foreign_check("init") && (%iconfig = &foreign_config("init")) &&
    $iconfig{'init_dir'}) {
	print "<table width=100%><tr>\n";
	&foreign_require("init", "init-lib.pl");
	foreach $a (&init::list_actions()) {
		local @a = split(/\s+/, $a);
		if ($a[0] eq "usermin") {
			$exists++;
			local @boot = &init::get_inittab_runlevel();
			foreach $s (&init::action_levels("S", $a[0])) {
				local ($l, $p) = split(/\s+/, $s);
				$starting++ if (&indexof($l, @boot) >= 0);
				}
			}
		}
	if ($starting && $iconfig{'daemons_dir'} &&
	    &read_env_file("$iconfig{'daemons_dir'}/usermin", \%daemon)) {
		$starting = lc($daemon{'ONBOOT'}) eq 'yes' ? 1 : 0;
		}

	print "<form action=bootup.cgi>\n";
	print "<input type=hidden name=exists value='$exists'>\n";
	print "<input type=hidden name=starting value='$starting'>\n";
	print "<td nowrap><input type=submit value='$text{'index_boot'}'>\n";
	printf "<input type=radio name=boot value=1 %s> %s\n",
		$starting ? "checked" : "", $text{'yes'};
	printf "<input type=radio name=boot value=0 %s> %s</td>\n",
		$starting ? "" : "checked", $text{'no'};
	print "<td>$text{'index_bootmsg'}</td>\n";
	print "</form></tr></table>\n";
	}

print "<hr>\n";
&footer("/", $text{'index'});
